<app-page-title [heading]="heading" [subheading]="subheading" [icon]="icon">
  <button (click)="getReporte()" class="btn btn-primary" [disabled]="!formSearch.valid || loading">
    <i class="fas fa-search mr-2"></i>Buscar
  </button>
  <button (click)="exportPDF()" class="btn ml-1 btn-danger" [disabled]="!dataGrid.length || loading">
    <i class="fa fa-file-pdf mr-2"></i>PDF
  </button>
  <button (click)="exportExcel()" class="btn ml-1 btn-success" [disabled]="!dataGrid.length || loading">
    <i class="fa fa-file-excel mr-2"></i>Excel
  </button>
  <button (click)="openModal(modal1)" class="btn ml-1 btn-info" [disabled]="!dataGrid.length || loading">
    <i class="fa fa-external-link-alt mr-2"></i>Detalle
  </button>
  <button (click)="openModal(modal2)" class="btn ml-1 btn-success" [disabled]="!dataGrid.length || loading">
    <i class="fa fa-dollar-sign mr-2"></i>Totales
  </button>
</app-page-title>

<div class="main-card mb-3 card">
  <div class="card-body">
    <ngx-loading [show]="loading" [config]="loadingColor"></ngx-loading>
    <form [formGroup]="formSearch">
      <div class="row animated fadeIn d-flex justify-content-start">
        <div class="row-fluid col-5 col-sm-3 col-md-3 col-lg-3 col-xl-3">
          <div class="form-group">
            <label for="rturno">Tipo Reporte</label>
            <kendo-dropdownlist [data]="dsTipoReporte" name="rturno" class="w-100" formControlName="rturno"
              (valueChange)="changeTipoReporte()" [textField]="'field'" [valueField]="'value'" [valuePrimitive]="true">
            </kendo-dropdownlist>
          </div>
        </div>
        <div class="row-fluid col-xl-4" *ngIf="!formSearch.value.rturno">
          <div class="form-group">
            <label for="usuario">Usuario</label>
            <kendo-multiselect [data]="dsUsuarios" name="usuario" class="w-100" formControlName="usuario"
              placeholder="Seleccionar usuario" [filterable]="true" [textField]="'cUserId'" [valueField]="'cUserId'"
              [valuePrimitive]="true">
            </kendo-multiselect>
          </div>
          <div class="form-group">
            <label for="meseroSelected">Estatus Cheque</label>
            <kendo-multiselect [data]="dsEstatusCheque" name="estatus" class="w-100" formControlName="estatus"
              placeholder="Seleccionar estatus" [textField]="'field'" [valueField]="'value'">
            </kendo-multiselect>
          </div>
        </div>
        <div class="row-fluid col-sm-12 col-md-3 col-lg-3 col-xl-2">
          <div class="form-group">
            <kendo-daterange>
              <label>Fecha Desde</label>
              <kendo-dateinput kendoDateRangeStartInput formControlName="fechaIni" class="w-100" [format]="formatKendo">
              </kendo-dateinput>
              <label class="mt-1">Fecha Hasta</label>
              <kendo-dateinput kendoDateRangeEndInput formControlName="fechaFin" class="w-100" [format]="formatKendo">
              </kendo-dateinput>
            </kendo-daterange>
          </div>
        </div>
        <div class="row-fluid col-sm-12 col-md-5 col-lg-5 col-xl-5">
          <div>
            <label for="punto">Punto</label>
            <kendo-dropdownlist [data]="dsPuntos" name="punto" class="w-100" formControlName="punto"
              (valueChange)="changePunto($event)" [textField]="'pdesc'" [valueField]="'Punto'" [valuePrimitive]="true">
            </kendo-dropdownlist>
          </div>
          <div class="row">
            <div class="col-6">
              <label for="clase">Clase</label>
              <kendo-dropdownlist [data]="dsClases" name="clase" class="w-100" formControlName="clase"
                [textField]="'cdesc'" [valueField]="'clase'" [valuePrimitive]="true">
              </kendo-dropdownlist>
            </div>
            <div class="col-6">
              <label for="turno">Turno</label>
              <kendo-dropdownlist [data]="dsTurnos" name="turno" class="w-100" formControlName="turno"
                [textField]="'tdesc'" [valueField]="'Turno'" [valuePrimitive]="true">
              </kendo-dropdownlist>
            </div>
          </div>
        </div>
      </div>
    </form>
    <kendo-grid [kendoGridBinding]="dataGrid" [selectable]="true" [navigable]="true" [reorderable]="true"
      [resizable]="true" [scrollable]="'virtual'" [filter]="filter" [filterable]="false" [rowHeight]="40"
      [groupable]="{ showFooter: true }" [group]="groups" (groupChange)="groupChange($event)"
      (dataStateChange)="dataStateChange($event)" style="height: 55vh;">
      <ng-container *ngIf="dataGrid.length !== 0">
        <kendo-grid-column field="tpunto" title="Punto" [filterable]="true" width="85" class="text-right">
        </kendo-grid-column>
        <kendo-grid-column field="tcheq" title="#Cheq." [filterable]="false" width="105" class="text-right">
        </kendo-grid-column>
        <kendo-grid-column field="tmese" title="Mesero" [filterable]="true" width="95"></kendo-grid-column>
        <kendo-grid-column field="tmesa" title="Mesa" [filterable]="true" width="85" media="md">
        </kendo-grid-column>
        <kendo-grid-column field="tpers" title="Pers." [filterable]="true" width="85" class="text-right" media="md">
        </kendo-grid-column>
        <kendo-grid-column field="tTotal" title="Total A & B" [filterable]="false" width="110" class="text-right">
          <ng-template kendoGridCellTemplate let-dataItem>
            {{ dataItem.tTotal | number:'1.2-2' }}
          </ng-template>
          <ng-container *ngIf="dataGrid">
            <ng-template kendoGridGroupFooterTemplate let-group="group" let-dataItem let-column="column" let-aggregates>
              <div class="text-right">
                <strong> {{ aggregates["tTotal"].sum | number:'1.2-2'}}</strong>
              </div>
            </ng-template>
            <ng-template kendoGridFooterTemplate let-dataItem let-column="column">
              <div class="text-right">
                <strong>{{ total["tTotal"].sum | number:'1.2-2' }}</strong>
              </div>
            </ng-template>
          </ng-container>
        </kendo-grid-column>
        <kendo-grid-column field="tserv" title="Serv. Paq." [filterable]="false" width="115" media="md"
          class="text-right">
          <ng-template kendoGridCellTemplate let-dataItem>{{ dataItem.tserv | number:'1.2-2' }}
          </ng-template>
          <ng-container *ngIf="dataGrid">
            <ng-template kendoGridGroupFooterTemplate let-group="group" let-aggregates>
              <div class="text-right">
                <strong>{{aggregates["tserv"].sum | number:'1.2-2'}}</strong>
              </div>
            </ng-template>
            <ng-template kendoGridFooterTemplate let-column="column">
              <div class="text-right">
                <strong>{{total["tserv"].sum | number:'1.2-2'}}</strong>
              </div>
            </ng-template>
          </ng-container>
        </kendo-grid-column>
        <kendo-grid-column field="tprop" title="Servicio" [filterable]="false" width="100" class="text-right">
          <ng-template kendoGridCellTemplate let-dataItem>{{ dataItem.tprop | number:'1.2-2' }}
          </ng-template>
          <ng-container *ngIf="dataGrid">
            <ng-template kendoGridGroupFooterTemplate let-group="group" let-aggregates>
              <div class="text-right">
                <strong>{{aggregates["tprop"].sum | number:'1.2-2'}}</strong>
              </div>
            </ng-template>
            <ng-template kendoGridFooterTemplate let-column="column">
              <div class="text-right">
                <strong>{{total["tprop"].sum | number:'1.2-2'}}</strong>
              </div>
            </ng-template>
          </ng-container>
        </kendo-grid-column>
        <kendo-grid-column field="tdesc" title="Descto." [filterable]="true" width="100" class="text-right">
          <ng-template kendoGridCellTemplate let-dataItem>{{ dataItem.tdesc | number:'1.2-2' }}
          </ng-template>
          <ng-container *ngIf="dataGrid">
            <ng-template kendoGridGroupFooterTemplate let-group="group" let-aggregates>
              <div class="text-right">
                <strong>{{aggregates["tdesc"].sum | number:'1.2-2'}}</strong>
              </div>
            </ng-template>
            <ng-template kendoGridFooterTemplate let-column="column">
              <div class="text-right">
                <strong>{{total["tdesc"].sum | number:'1.2-2'}}</strong>
              </div>
            </ng-template>
          </ng-container>
        </kendo-grid-column>
        <kendo-grid-column field="tcod" title="Código" [filterable]="false" width="90" media="md">
        </kendo-grid-column>
        <kendo-grid-column field="tmonto" title="Importe" [filterable]="true" width="105" class="text-right">
          <ng-template kendoGridCellTemplate let-dataItem>{{ dataItem.tmonto | number:'1.2-2' }}
          </ng-template>
          <ng-container *ngIf="dataGrid">
            <ng-template kendoGridGroupFooterTemplate let-group="group" let-aggregates>
              <div class="text-right">
                <strong>{{aggregates["tmonto"].sum | number:'1.2-2'}}</strong>
              </div>
            </ng-template>
            <ng-template kendoGridFooterTemplate let-column="column">
              <div class="text-right">
                <strong>{{total["tmonto"].sum | number:'1.2-2'}}</strong>
              </div>
            </ng-template>
          </ng-container>
        </kendo-grid-column>
        <kendo-grid-column field="tcto" title="Cuarto" [filterable]="false" width="90" media="md">
        </kendo-grid-column>
        <kendo-grid-column field="tea" title="E.A." [filterable]="false" width="75"></kendo-grid-column>
        <kendo-grid-column field="tope" title="Ope." [filterable]="true" width="75" media="md">
        </kendo-grid-column>
        <!-- <kendo-grid-column field="tnchq"   title="Voucher"  [filterable]="false" width="100" media="md" class="text-right"></kendo-grid-column> -->
      </ng-container>
      <ng-template kendoGridNoRecordsTemplate>
        {{ norecords }}
      </ng-template>
    </kendo-grid>
  </div>
</div>

<ng-template #modal1 let-c="close" let-d="dismiss" class="animated flipInX">
  <div class="modal-header">
    <h6 class="modal-title">
      <i class="fas fa-search mr-2"></i> Detalle Reporte de Turno
    </h6>
    <button class="close" aria-label="Close" (click)="d('Cross click')">
      <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="modal-body">
    <kendo-grid [data]="dsResumen" [selectable]="true" [navigable]="true" [reorderable]="true" [resizable]="true"
      style="height: 70vh;">
      <kendo-grid-column field="tpunto" title="Punto" width="65" class="text-right"></kendo-grid-column>
      <kendo-grid-column field="tdtm" title="TM" width="120"></kendo-grid-column>
      <kendo-grid-column field="tinga" title="Alimentos" width="100" class="text-right">
        <ng-template kendoGridCellTemplate let-dataItem>{{ dataItem.tinga | number:'1.2-2' }}
        </ng-template>
      </kendo-grid-column>
      <kendo-grid-column field="tingb" title="Bebidas" width="100" class="text-right">
        <ng-template kendoGridCellTemplate let-dataItem>{{ dataItem.tingb | number:'1.2-2' }}
        </ng-template>
      </kendo-grid-column>
      <kendo-grid-column field="tingv" title="Varios" width="90" class="text-right">
        <ng-template kendoGridCellTemplate let-dataItem>{{ dataItem.tingv | number:'1.2-2' }}
        </ng-template>
      </kendo-grid-column>
      <kendo-grid-column field="tserv" title="Serv. Paq." width="100" class="text-right">
        <ng-template kendoGridCellTemplate let-dataItem>{{ dataItem.tserv | number:'1.2-2' }}
        </ng-template>
      </kendo-grid-column>
      <kendo-grid-column field="tprop" title="Servicio" width="100" class="text-right">
        <ng-template kendoGridCellTemplate let-dataItem>{{ dataItem.tprop | number:'1.2-2' }}
        </ng-template>
      </kendo-grid-column>
      <kendo-grid-column field="tdesc" title="Desctos" width="100" class="text-right">
        <ng-template kendoGridCellTemplate let-dataItem>{{ dataItem.tdesc | number:'1.2-2' }}
        </ng-template>
      </kendo-grid-column>
      <kendo-grid-column field="timpto" title="Impuestos" width="100" class="text-right">
        <ng-template kendoGridCellTemplate let-dataItem>{{ dataItem.timpto | number:'1.2-2' }}
        </ng-template>
      </kendo-grid-column>
      <kendo-grid-column field="ttotal" title="Total" width="100" class="text-right">
        <ng-template kendoGridCellTemplate let-dataItem>{{ dataItem.ttotal | number:'1.2-2' }}
        </ng-template>
      </kendo-grid-column>
    </kendo-grid>
  </div>
  <div class="modal-footer">
    <button class="btn btn-shadow btn-secondary" (click)="c('Close click')">
      Cerrar
    </button>
  </div>
</ng-template>
<ng-template #modal2 let-c="close" let-d="dismiss" class="animated flipInX">
  <div class="modal-header">
    <h6 class="modal-title">
      <i class="fas fa-search mr-2"></i>Total por código
    </h6>
    <button class="close" aria-label="Close" (click)="d('Cross click')">
      <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="modal-body">
    <kendo-grid [data]="dsCodigosComplete" [selectable]="true" [navigable]="true" [reorderable]="true"
      [resizable]="true" style="height: 70vh;">
      <kendo-grid-column field="tcod" title="Código" width="70"></kendo-grid-column>
      <kendo-grid-column field="tdesc" title="Descripción" width="150"></kendo-grid-column>
      <kendo-grid-column field="tmonto" title="Importe" width="100" class="text-right">
        <ng-template kendoGridCellTemplate let-dataItem>{{ dataItem.tmonto | number:'1.2-2' }}
        </ng-template>
      </kendo-grid-column>
    </kendo-grid>
  </div>
  <div class="modal-footer">
    <button class="btn btn-shadow btn-secondary" (click)="c('Close click')">
      Cerrar
    </button>
  </div>
</ng-template>

<div id="tblExcel" style="display: none;">
  <table id="tbl1" border="2">
    <thead>
      <tr>
        <th>Fecha</th>
        <th>Clase</th>
        <th>Punto</th>
        <th>Cheque</th>
        <th>Mesero</th>
        <th>Mesa</th>
        <th>Pers.</th>
        <th>Alim.</th>
        <th>Beb.</th>
        <th>Var.</th>
        <th>Serv. Paq.</th>
        <th>Serv.</th>
        <th>Total</th>
        <th>Descto.</th>
        <th>FP</th>
        <th>Importe</th>
        <th>Cuarto</th>
        <th>Vou.</th>
        <th>E.A.</th>
        <th>Ope.</th>
        <td>Abierto</td>
        <td>Impreso</td>
        <td>Cerrado</td>
        <td>Cxld</td>
      </tr>
    </thead>
    <tbody>
      <tr *ngFor="let item of dataGrid">
        <td>{{ item.tFecha }}</td>
        <td>{{ item.tclase }}</td>
        <td>{{ item.tpunto }}</td>
        <td>{{ item.tcheq }}</td>
        <td>{{ item.tmese }}</td>
        <td>{{ item.tmesa }}</td>
        <td>{{ item.tpers }}</td>
        <td>{{ item.tinga  | number:'1.2-2' }}</td>
        <td>{{ item.tingb  | number:'1.2-2' }}</td>
        <td>{{ item.tingv  | number:'1.2-2' }}</td>
        <td>{{ item.tserv  | number:'1.2-2' }}</td>
        <td>{{ item.tprop  | number:'1.2-2' }}</td>
        <td>{{ item.tTotal | number:'1.2-2' }}</td>
        <td>{{ item.tdesc  | number:'1.2-2' }}</td>
        <td>{{ item.tcod }}</td>
        <td>{{ item.tmonto | number:'1.2-2' }}</td>
        <td>{{ item.tcto }}</td>
        <td>{{ item.tnchq }}</td>
        <td>{{ item.tea }}</td>
        <td>{{ item.tope }}</td>
        <td>{{ item.theact1 | date:'shortTime' }}</td>
        <td>{{ item.theact2 | date:'shortTime' }}</td>
        <td>{{ item.theact3 | date:'shortTime' }}</td>
        <td>{{ item.theact4 | date:'shortTime' }}</td>
      </tr>
      <tr>
        <td></td>
      </tr>
    </tbody>
  </table>
  <table id="tbl2" border="2">
    <thead>
      <tr>
        <th></th>
        <th></th>
        <th></th>
        <th>Alimentos</th>
        <th>Bebidas</th>
        <th>Varios</th>
        <th>Serv. Paq.</th>
        <th>Servicio</th>
        <th>Descuentos</th>
        <th>Impuestos</th>
        <th>Total</th>
      </tr>
    </thead>
    <tbody>
      <tr *ngFor="let item of dsResumen">
        <td></td>
        <td></td>
        <td>{{ item.tdtm }}</td>
        <td>{{ item.tinga  | number:'1.2-2' }}</td>
        <td>{{ item.tingb  | number:'1.2-2' }}</td>
        <td>{{ item.tingv  | number:'1.2-2' }}</td>
        <td>{{ item.tserv  | number:'1.2-2' }}</td>
        <td>{{ item.tprop  | number:'1.2-2' }}</td>
        <td>{{ item.tdesc  | number:'1.2-2' }}</td>
        <td>{{ item.timpto | number:'1.2-2' }}</td>
        <td>{{ item.ttotal | number:'1.1-2' }}</td>
      </tr>
      <tr>
        <td></td>
      </tr>
    </tbody>
  </table>
  <br>
  <table id="tbl3" border="2">
    <thead>
      <tr>
        <th></th>
        <th></th>
        <th>Forma de Pago:</th>
        <th></th>
        <th></th>
      </tr>
    </thead>
    <tbody>
      <tr *ngFor="let item of dsCodigos">
        <td></td>
        <td></td>
        <td>{{ item.tcod }}</td>
        <td>{{ item.tdesc }}</td>
        <td>{{ item.tmonto | number:'1.2-2' }}</td>
      </tr>
      <tr>
        <td colspan="5" align="center" *ngIf="dsCuadra && dsCuadra[0]">
          <strong>{{ dsCuadra[0].EtiCuadre }}</strong>
        </td>
      </tr>
    </tbody>
  </table>
</div>
